# The software in this package is distributed under the GNU General
# Public License version 2 (with a special exception described below).
#
# A copy of GNU General Public License (GPL) is included in this distribution,
# in the file COPYING.GPL.
#
# As a special exception, if other files instantiate templates or use macros
# or inline functions from this file, or you compile this file and link it
# with other works to produce a work based on this file, this file
# does not by itself cause the resulting work to be covered
# by the GNU General Public License.
#
# However the source code for this file must still be made available
# in accordance with section (3) of the GNU General Public License.
#
# This exception does not invalidate any other reasons why a work based
# on this file might be covered by the GNU General Public License.
#
# Copyright (c) 2016-2018 Intra2net AG <info@intra2net.com>

from .build_cnfvar import BuildCnfVar
"""Class to create proxy accesslists on the fly"""


class BuildProxyAccesslist(BuildCnfVar):
    def __init__(self, data='', instance=0, line_no=1):
        BuildCnfVar.__init__(self, 'PROXY_ACCESSLIST', instance, data, line_no)

        defaults = {'PROXY_ACCESSLIST_ENTRY_COUNT': '123',
                    'PROXY_ACCESSLIST_MODE': '1',
                    'PROXY_ACCESSLIST_SIZETYPE': 1,
                    'PROXY_ACCESSLIST_TYPE': 0}

        self.add_defaults(defaults)

    def mode_whitelist(self):
        self.update_cnf('PROXY_ACCESSLIST_MODE', 0, '0')
        return self

    def mode_blacklist(self):
        self.update_cnf('PROXY_ACCESSLIST_MODE', 0, '1')
        return self

    def add_url(self, url):
        self.add_cnf('PROXY_ACCESSLIST_URL', -1, url)
        return self
